unit Unit2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Buttons,
  ButtonPanel;

type

  { TForm2 }

  TForm2 = class(TForm)
    ButtonPanel1: TButtonPanel;
    Stelle1000: TLabel;
    Stelle100: TLabel;
    Stelle10: TLabel;
    Stelle1: TLabel;
    BtnInc1000: TSpeedButton;
    BtnInc100: TSpeedButton;
    BtnInc10: TSpeedButton;
    BtnInc1: TSpeedButton;
    BtnDec1000: TSpeedButton;
    BtnDec100: TSpeedButton;
    BtnDec10: TSpeedButton;
    BtnDec1: TSpeedButton;
    procedure BtnIncDecStelleClick(Sender: TObject);
  private
    function GetValue: Integer;
    procedure SetValue(AValue: Integer);

  public
    property Value: Integer read GetValue write Setvalue;

  end;

var
  Form2: TForm2;


implementation

{$R *.lfm}

{ TForm2 }

procedure TForm2.BtnIncDecStelleClick(Sender: TObject);

  procedure DoIt(ALabel: TLabel; ADelta: Integer);
  var
    val: Integer;
  begin
    val := StrToInt(ALabel.Caption);
    inc(val, ADelta);
    if val > 9 then val := 9;
    if val < 0 then val := 0;
    ALabel.Caption := IntToStr(val);
  end;

begin
  if Sender = BtnInc1000 then DoIt(Stelle1000, +1) else
  if Sender = BtnDec1000 then DoIt(Stelle1000, -1) else
  if Sender = BtnInc100  then DoIt(Stelle100, +1) else
  if Sender = BtnDec100  then DoIt(Stelle100, -1) else
  if Sender = BtnInc10   then DoIt(Stelle10, +1) else
  if Sender = BtnDec10   then DoIt(Stelle10, -1) else
  if Sender = BtnInc1    then DoIt(Stelle1, +1) else
  if Sender = BtnDec1    then DoIt(Stelle1, -1);
end;

function TForm2.GetValue: Integer;
begin
  Result := StrToInt(Stelle1000.Caption)*1000 +
            StrToInt(Stelle100.caption) * 100 +
            StrToInt(Stelle10.Caption)  *  10 +
            StrToInt(Stelle1.Caption)   *   1;
end;

procedure TForm2.SetValue(AValue: Integer);
var
  valStr: String;
  len: Integer;
begin
  valStr := IntToStr(AValue);
  len := Length(valstr);
  if len > 0 then
    Stelle1.Caption := valStr[len] else Stelle1.Caption := '0';
  if len > 1 then
    Stelle10.Caption := valStr[len-1] else Stelle10.Caption := '0';
  if len > 2 then
    Stelle100.Caption := valStr[len-2] else Stelle100.Caption := '0';
  if len > 3 then
    Stelle1000.Caption := valStr[len-3]  else Stelle1000.Caption := '0';
end;

end.

